<h1 align="center">
  Software-Driven RDM</br>
  <a href="https://badge.fury.io/py/sdRDM"><img src="https://badge.fury.io/py/sdRDM.svg" alt="PyPI version" height="18"></a>
  <img src="https://img.shields.io/badge/python-3.9|3.10|3.11-blue.svg" alt="Build Badge">
  <img src="https://github.com/JR-1991/software-driven-rdm/actions/workflows/tests.yml/badge.svg" alt="Build Badge">
</h1>
<p align="center">
With Software-driven Research Data Management (sdRDM), you can confidently specify data models using verbose Markdown documents and effortlessly convert them into powerful Python objects that can be serialized into any data exchange format.
</p>

### 🏎 Features

- Generate and maintain RDM APIs via readable specifications in __Markdown__
- Data Models defined in sdRDM can be exported to __any format__
- Link your data model to any other data model and setup __workflows__

## ⚡️ Quick start

Get started with by running the following command

```bash
# Using PIP
python -m pip install sdRDM
```

Or build by source

```bash
git clone https://github.com/JR-1991/software-driven-rdm.git
cd software-driven-rdm
python3 setup.py install
```

## 📖 Documentation and more examples

In the making! 🐛

## 📦 Other sdRDM-related repositories

* [Code generator for GitHub Actions](https://github.com/JR-1991/generate-sdrdm-api/tree/main)
: Deposit your Markdown-based data model in a GitHub repository and automatically generate a Python API upon changes.
* [Create a database from a Markdown-based data model](https://github.com/JR-1991/sdrdm-database)
: Use your data model to create a relational database and interact with it via a Python API.

## ⚠️ License

`sdRDM` is free and open-source software licensed under the MIT License.
